/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             List
*  SCOPE :              List common services
*  FILE :               list.cc
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif

/* IMPORTS *******************************************************************/

#ifndef __listln_HXX
#include "listln.hxx"
#endif

/*****************************************************************************/

/*= EXTERNAL FUNCTION =======================================================*/
Ref<Collection> ListLeaf::clone()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return new(this->getCluster(), this->getClass()) ListLeaf(0) ;
}


/*= EXTERNAL FUNCTION =======================================================*/
Ref<ColNode> ListLeaf::newNode()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return new(this->getCluster(), YOO_LISTNODE_CLID) ListNode(0) ;
}


/*= EXTERNAL FUNCTION =======================================================*/
void ListLeaf::yoo_refresh(void* addr)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  YOO_LOAD_TIME = TRUE ;
  new(addr) ListLeaf ;
  YOO_LOAD_TIME = FALSE ;
}


/*= EXTERNAL FUNCTION =======================================================*/
Ref<Collection> ListNode::clone()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return new(this->getCluster(), this->getClass()) ListNode(0) ;
}


/*= EXTERNAL FUNCTION =======================================================*/
ColElem* ListNode::tab(int pos)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return (ColElem*) &(this->_tab[pos*sizeof(ColNodeElem)]) ;
}


/*= EXTERNAL FUNCTION =======================================================*/
int ListNode::sizeElem()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return sizeof(ColNodeElem ) ;
}


/*= EXTERNAL FUNCTION =======================================================*/
int ListNode::maxElem()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  return ListNbInNode ;
}


/*= EXTERNAL FUNCTION =======================================================*/
void ListNode::yoo_refresh(void* addr)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  YOO_LOAD_TIME = TRUE ;
  new(addr) ListNode ;
  YOO_LOAD_TIME = FALSE ;
}


